Index: /code/branches/core/src/orxonox/Orxonox.cc
===================================================================
--- /code/branches/core/src/orxonox/Orxonox.cc	(revision 805)
+++ /code/branches/core/src/orxonox/Orxonox.cc	(revision 806)
@@ -206,10 +206,10 @@
   {
     //TODO: start modules
-    ogre_->startRender();
+//    ogre_->startRender();
     //TODO: run engine
     Factory::createClassHierarchy();
-    createScene();
-    setupScene();
-    setupInputSystem();
+//    createScene();
+//    setupScene();
+//    setupInputSystem();
     if(mode_!=CLIENT){ // remove this in future ---- presentation hack
     }
@@ -829,7 +829,5 @@
         test13_2.exclude(Class(A3B2C2));
 
-//        TestClassTreeMask(test13_1);
-std::cout << "1_0: " << ClassIdentifier<BaseObject>::getIdentifier() << std::endl;
-
+        TestClassTreeMask(test13_1);
         TestClassTreeMask(test13_2);
 
Index: /code/branches/core/src/orxonox/core/ClassManager.h
===================================================================
--- /code/branches/core/src/orxonox/core/ClassManager.h	(revision 805)
+++ /code/branches/core/src/orxonox/core/ClassManager.h	(revision 806)
@@ -52,5 +52,4 @@
 
             bool bInitialized_;
-//            std::string name_;
             ClassIdentifier<T>* identifier_;
     };
@@ -65,4 +64,8 @@
     }
 
+    /**
+        @brief Returns the one and only instance of this class for the template parameter T.
+        @return The instance
+    */
     template <class T>
     ClassManager<T>* ClassManager<T>::getSingleton()
Index: /code/branches/core/src/orxonox/core/ClassTreeMask.cc
===================================================================
--- /code/branches/core/src/orxonox/core/ClassTreeMask.cc	(revision 805)
+++ /code/branches/core/src/orxonox/core/ClassTreeMask.cc	(revision 806)
@@ -237,17 +237,17 @@
     bool ClassTreeMask::isIncluded(ClassTreeMaskNode* node, const Identifier* subclass) const
     {
-std::cout << "1_1: " << subclass->getName() << " (" << subclass << ") / " << node->getClass()->getName() << " (" << node->getClass() << ")" << std::endl;
+//std::cout << "1_1: " << subclass->getName() << " (" << subclass << ") / " << node->getClass()->getName() << " (" << node->getClass() << ")" << std::endl;
         // Check if the searched subclass is of the same type as the class in the current node or a derivative
         if (subclass->isA(node->getClass()))
         {
-std::cout << "1_2\n";
+//std::cout << "1_2\n";
             // Check for the special case
             if (subclass == node->getClass())
             {
-std::cout << "1_3\n";
+//std::cout << "1_3\n";
                 return node->isIncluded();
             }
 
-std::cout << "1_4\n";
+//std::cout << "1_4\n";
             // Go through the list of subnodes and look for a node containing the searched subclass
             for (std::list<ClassTreeMaskNode*>::iterator it = node->subnodes_.begin(); it != node->subnodes_.end(); ++it)
@@ -255,5 +255,5 @@
                     return isIncluded(*it, subclass);
 
-std::cout << "1_5\n";
+//std::cout << "1_5\n";
             // There is no subnode containing our class -> the rule of the current node takes in effect
             return node->isIncluded();
@@ -261,5 +261,5 @@
         else
         {
-std::cout << "1_6\n";
+//std::cout << "1_6\n";
             // The class is not included in the mask: return false
             return false;
Index: /code/branches/core/src/orxonox/core/Identifier.cc
===================================================================
--- /code/branches/core/src/orxonox/core/Identifier.cc	(revision 805)
+++ /code/branches/core/src/orxonox/core/Identifier.cc	(revision 806)
@@ -117,13 +117,4 @@
 
     /**
-        @returns a reference to the Identifier map, containing all Identifiers.
-    *//*
-    std::map<std::string, Identifier*>& Identifier::getIdentifierMap()
-    {
-        static std::map<std::string, Identifier*> identifierMapStaticReference = std::map<std::string, Identifier*>();
-        return identifierMapStaticReference;
-    }*/
-
-    /**
         @returns true, if the Identifier is at least of the given type.
         @param identifier The identifier to compare with
Index: /code/branches/core/src/orxonox/core/Identifier.h
===================================================================
--- /code/branches/core/src/orxonox/core/Identifier.h	(revision 805)
+++ /code/branches/core/src/orxonox/core/Identifier.h	(revision 806)
@@ -106,6 +106,4 @@
             bool isParentOf(const Identifier* identifier) const;
 
-//            static std::map<std::string, Identifier*>& getIdentifierMap();
-
             /** @brief Removes all objects of the corresponding class. */
             virtual void removeObjects() const = 0;
@@ -192,5 +190,4 @@
             ClassIdentifier<T>* registerClass(const IdentifierList* parents, const std::string& name, bool bRootClass);
             void addObject(T* object);
-//            static ClassIdentifier<T>* getIdentifier();
             void removeObjects() const;
             void setName(const std::string& name);
@@ -244,23 +241,4 @@
 
     /**
-        @brief Creates the only instance of this class for the template class T.
-        @return The Identifier itself
-    *//*
-    template <class T>
-    ClassIdentifier<T>* ClassIdentifier<T>::getIdentifier()
-    {
-        static ClassIdentifier<T> theOneAndOnlyInstance = ClassIdentifier<T>();
-        static bool bIdentifierCreated = false;
-
-        if (!bIdentifierCreated)
-        {
-            COUT(4) << "*** Create Identifier Singleton." << std::endl;
-            bIdentifierCreated = true;
-        }
-
-        return &theOneAndOnlyInstance;
-    }
-*/
-    /**
         @brief Sets the name of the class.
         @param name The name
@@ -269,9 +247,7 @@
     void ClassIdentifier<T>::setName(const std::string& name)
     {
-//        // Make sure we didn't already set the name, to avoid duplicate entries in the Identifier map
         if (!this->bSetName_)
         {
             this->name_ = name;
-//            this->getIdentifierMap().insert(std::pair<std::string, Identifier*>(name, this));
             this->bSetName_ = true;
         }