Index: code/branches/core/src/orxonox/core/BaseObject.cc
===================================================================
--- code/branches/core/src/orxonox/core/BaseObject.cc	(revision 825)
+++ code/branches/core/src/orxonox/core/BaseObject.cc	(revision 826)
@@ -66,3 +66,16 @@
         }
     }
+
+    /**
+        @brief XML loading and saving.
+        @param xmlelement The XML-element
+        @param loading Loading (true) or saving (false)
+        @return The XML-element
+    */
+    Element& BaseObject::XMLPort(Element& xmlelement, bool loading)
+    {
+//        XMLPortParam(BaseObject, "name", setName, getName, xmlelement, loading);
+
+        return xmlelement;
+    }
 }
Index: code/branches/core/src/orxonox/core/BaseObject.h
===================================================================
--- code/branches/core/src/orxonox/core/BaseObject.h	(revision 825)
+++ code/branches/core/src/orxonox/core/BaseObject.h	(revision 826)
@@ -37,5 +37,5 @@
 
 #include "CorePrereqs.h"
-#include "util/tinyxml/TinyXMLPrereqs.h"
+#include "util/XMLIncludes.h"
 
 #include "CoreIncludes.h"
@@ -50,4 +50,5 @@
             virtual ~BaseObject();
             virtual void loadParams(TiXmlElement* xmlElem);
+            virtual Element& XMLPort(Element& xmlelement, bool loading);
 
             /** @brief Returns a pointer to the level that loaded this object. @return The level */
Index: code/branches/core/src/orxonox/core/ConfigValueContainer.cc
===================================================================
--- code/branches/core/src/orxonox/core/ConfigValueContainer.cc	(revision 825)
+++ code/branches/core/src/orxonox/core/ConfigValueContainer.cc	(revision 826)
@@ -36,4 +36,5 @@
 #include "util/Tokenizer.h"
 #include "util/Convert.h"
+#include "Language.h"
 
 #define CONFIGFILEPATH "orxonox.ini"
@@ -951,3 +952,12 @@
         }
     }
+
+    /**
+        @brief Returns the description of the config-value.
+        @return The description
+    */
+    std::string ConfigValueContainer::getDescription() const
+    {
+        return Language::getLanguage().getTranslation(this->description_);
+    }
 }
Index: code/branches/core/src/orxonox/core/ConfigValueContainer.h
===================================================================
--- code/branches/core/src/orxonox/core/ConfigValueContainer.h	(revision 825)
+++ code/branches/core/src/orxonox/core/ConfigValueContainer.h	(revision 826)
@@ -50,5 +50,4 @@
 #include "util/Math.h"
 #include "util/MultiTypeMath.h"
-#include "Language.h"
 
 namespace orxonox
@@ -101,4 +100,5 @@
 
             void description(const std::string& description);
+            std::string getDescription() const;
 
             bool parseString(const std::string& input, MultiTypeMath& defvalue);
Index: code/branches/core/src/orxonox/core/CorePrereqs.h
===================================================================
--- code/branches/core/src/orxonox/core/CorePrereqs.h	(revision 825)
+++ code/branches/core/src/orxonox/core/CorePrereqs.h	(revision 826)
@@ -34,4 +34,6 @@
 #define _CorePrereqs_H__
 
+#include <string>
+
 #include "orxonox/OrxonoxPlatform.h"
 
@@ -63,4 +65,6 @@
 namespace orxonox
 {
+  typedef std::string LanguageEntryName;
+
   class ArgReader;
   class BaseFactory;
Index: code/branches/core/src/orxonox/core/Language.h
===================================================================
--- code/branches/core/src/orxonox/core/Language.h	(revision 825)
+++ code/branches/core/src/orxonox/core/Language.h	(revision 826)
@@ -53,6 +53,7 @@
 namespace orxonox
 {
-    typedef std::string LanguageEntryName;
-
+    // ###############################
+    // ###      LanguageEntry      ###
+    // ###############################
     //! The LanguageEntry class stores the default- and the translated string of a given entry in the language file.
     class _CoreExport LanguageEntry : public OrxonoxClass
@@ -85,4 +86,8 @@
     template class _CoreExport orxonox::ObjectList<LanguageEntry>;
 
+
+    // ###############################
+    // ###         Language        ###
+    // ###############################
     //! The Language class manges the language files and entries and stores the LanguageEntry objects in a map.
     class _CoreExport Language : public OrxonoxClass
Index: code/branches/core/src/orxonox/core/Level.h
===================================================================
--- code/branches/core/src/orxonox/core/Level.h	(revision 825)
+++ code/branches/core/src/orxonox/core/Level.h	(revision 826)
@@ -52,3 +52,3 @@
 }
 
-#endif
+#endif /* _Level_H__ */
Index: code/branches/core/src/orxonox/core/Loader.h
===================================================================
--- code/branches/core/src/orxonox/core/Loader.h	(revision 825)
+++ code/branches/core/src/orxonox/core/Loader.h	(revision 826)
@@ -61,3 +61,3 @@
 }
 
-#endif
+#endif /* _Loader_H__ */
Index: code/branches/core/src/util/XMLIncludes.h
===================================================================
--- code/branches/core/src/util/XMLIncludes.h	(revision 826)
+++ code/branches/core/src/util/XMLIncludes.h	(revision 826)
@@ -0,0 +1,12 @@
+#include "util/tinyxml/TinyXMLPrereqs.h"
+
+namespace orxonox
+{
+    typedef ticpp::Document Document;
+    typedef ticpp::Element Element;
+    typedef ticpp::Declaration Declaration;
+    typedef ticpp::StylesheetReference StylesheetReference;
+    typedef ticpp::Text Text;
+    typedef ticpp::Comment Comment;
+    typedef ticpp::Attribute Attribute;
+}
Index: code/branches/core/src/util/tinyxml/TinyXMLPrereqs.h
===================================================================
--- code/branches/core/src/util/tinyxml/TinyXMLPrereqs.h	(revision 825)
+++ code/branches/core/src/util/tinyxml/TinyXMLPrereqs.h	(revision 826)
@@ -73,3 +73,14 @@
 class TiXmlParsingData;
 
+namespace ticpp
+{
+    class Document;
+    class Element;
+    class Declaration;
+    class StylesheetReference;
+    class Text;
+    class Comment;
+    class Attribute;
+}
+
 #endif /* _TinyXMLPrereqs_H__ */