Index: code/branches/core/src/network/Synchronisable.h
===================================================================
--- code/branches/core/src/network/Synchronisable.h	(revision 843)
+++ code/branches/core/src/network/Synchronisable.h	(revision 845)
@@ -2,5 +2,5 @@
 // C++ Interface: synchronisable
 //
-// Description: 
+// Description:
 //
 //
@@ -66,11 +66,4 @@
     int datasize;
   };
-
-}
-
-namespace orxonox
-{
-  template class _NetworkExport ClassIdentifier<network::Synchronisable>;
-  template class _NetworkExport ObjectList<network::Synchronisable>;
 }
 
Index: code/branches/core/src/orxonox/core/BaseObject.h
===================================================================
--- code/branches/core/src/orxonox/core/BaseObject.h	(revision 843)
+++ code/branches/core/src/orxonox/core/BaseObject.h	(revision 845)
@@ -58,5 +58,4 @@
             const Level* level_;                        //!< The level that loaded this object
     };
-    ExportClass(BaseObject, Core);
 }
 
Index: code/branches/core/src/orxonox/core/CoreIncludes.h
===================================================================
--- code/branches/core/src/orxonox/core/CoreIncludes.h	(revision 843)
+++ code/branches/core/src/orxonox/core/CoreIncludes.h	(revision 845)
@@ -91,23 +91,4 @@
 
 /**
-    @brief Exports the necessary templates in order to make them available to all libraries.
-    @param ClassName The name of the Class
-    @param LibraryName The name of the Library
-*/
-#define ExportClass(ClassName, LibraryName) \
-    template class _##LibraryName##Export orxonox::ClassIdentifier<ClassName>; \
-    template class _##LibraryName##Export orxonox::ObjectList<ClassName>; \
-    template class _##LibraryName##Export orxonox::ClassFactory<ClassName>
-
-/**
-    @brief Exports the necessary templates in order to make them available to all libraries.
-    @param ClassName The name of the Class
-    @param LibraryName The name of the Library
-*/
-#define ExportAbstractClass(ClassName, LibraryName) \
-    template class _##LibraryName##Export orxonox::ClassIdentifier<ClassName>; \
-    template class _##LibraryName##Export orxonox::ObjectList<ClassName>
-
-/**
     @brief Returns the Identifier of the given class.
     @param ClassName The name of the class
Index: code/branches/core/src/orxonox/core/DebugLevel.h
===================================================================
--- code/branches/core/src/orxonox/core/DebugLevel.h	(revision 843)
+++ code/branches/core/src/orxonox/core/DebugLevel.h	(revision 845)
@@ -66,5 +66,4 @@
             ConfigValueContainer* softDebugLevelContainer_; //!< The config value container for the debug level
     };
-    ExportAbstractClass(DebugLevel, Core);
 }
 
Index: code/branches/core/src/orxonox/core/Identifier.h
===================================================================
--- code/branches/core/src/orxonox/core/Identifier.h	(revision 843)
+++ code/branches/core/src/orxonox/core/Identifier.h	(revision 845)
Index: code/branches/core/src/orxonox/core/Language.h
===================================================================
--- code/branches/core/src/orxonox/core/Language.h	(revision 843)
+++ code/branches/core/src/orxonox/core/Language.h	(revision 845)
@@ -83,6 +83,4 @@
             bool bLocalisationSet_;                                 //!< True if the translation was set
     };
-    template class _CoreExport orxonox::ClassIdentifier<LanguageEntry>;
-    template class _CoreExport orxonox::ObjectList<LanguageEntry>;
 
 
@@ -118,6 +116,4 @@
             std::map<std::string, LanguageEntry*> languageEntries_; //!< A map to store all LanguageEntry objects and their labels
     };
-    template class _CoreExport orxonox::ClassIdentifier<Language>;
-    template class _CoreExport orxonox::ObjectList<Language>;
 }
 
Index: code/branches/core/src/orxonox/core/OrxonoxClass.h
===================================================================
--- code/branches/core/src/orxonox/core/OrxonoxClass.h	(revision 843)
+++ code/branches/core/src/orxonox/core/OrxonoxClass.h	(revision 845)
@@ -183,6 +183,4 @@
             bool bVisible_;                             //!< True = the object is visible
     };
-    template class _CoreExport orxonox::ClassIdentifier<OrxonoxClass>;
-    template class _CoreExport orxonox::ObjectList<OrxonoxClass>;
 }
 
Index: code/branches/core/src/orxonox/objects/Ambient.cc
===================================================================
--- code/branches/core/src/orxonox/objects/Ambient.cc	(revision 843)
+++ code/branches/core/src/orxonox/objects/Ambient.cc	(revision 845)
@@ -45,7 +45,4 @@
 namespace orxonox
 {
-    // create a template instantiations
-    //template class _OrxonoxExport ClassIdentifier<Ambient>;
-
     CreateFactory(Ambient);
 
Index: code/branches/core/src/orxonox/objects/Ambient.h
===================================================================
--- code/branches/core/src/orxonox/objects/Ambient.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/Ambient.h	(revision 845)
@@ -14,12 +14,11 @@
             virtual ~Ambient();
 
-            
+
             void loadParams(TiXmlElement* xmlElem);
 
         private:
-            
+
 
     };
-    ExportClass(Ambient, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/Camera.h
===================================================================
--- code/branches/core/src/orxonox/objects/Camera.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/Camera.h	(revision 845)
@@ -14,12 +14,11 @@
             virtual ~Camera();
 
-            
+
             void loadParams(TiXmlElement* xmlElem);
 
         private:
-            
+
 
     };
-    ExportClass(Camera, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/Explosion.h
===================================================================
--- code/branches/core/src/orxonox/objects/Explosion.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/Explosion.h	(revision 845)
@@ -21,5 +21,4 @@
             ParticleInterface* particle_;
     };
-    ExportClass(Explosion, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/Fighter.h
===================================================================
--- code/branches/core/src/orxonox/objects/Fighter.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/Fighter.h	(revision 845)
@@ -90,5 +90,4 @@
             int emitterRate_;
     };
-    ExportClass(Fighter, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/Model.h
===================================================================
--- code/branches/core/src/orxonox/objects/Model.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/Model.h	(revision 845)
@@ -25,5 +25,4 @@
             void registerAllVariables();
     };
-    ExportClass(Model, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/NPC.h
===================================================================
--- code/branches/core/src/orxonox/objects/NPC.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/NPC.h	(revision 845)
@@ -44,6 +44,4 @@
       static int const NUMELEMENTS = 9;  //number of elements
   };
-  ExportClass(NPC, Orxonox);
-
 }
 #endif /* _NPC_H__ */
Index: code/branches/core/src/orxonox/objects/Projectile.h
===================================================================
--- code/branches/core/src/orxonox/objects/Projectile.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/Projectile.h	(revision 845)
@@ -28,5 +28,4 @@
             Timer<Projectile> destroyTimer_;
     };
-    ExportClass(Projectile, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/Skybox.h
===================================================================
--- code/branches/core/src/orxonox/objects/Skybox.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/Skybox.h	(revision 845)
@@ -16,12 +16,11 @@
             virtual ~Skybox();
 
-            
+
             void loadParams(TiXmlElement* xmlElem);
 
         private:
-            
+
 
     };
-    ExportClass(Skybox, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/SpaceShip.h
===================================================================
--- code/branches/core/src/orxonox/objects/SpaceShip.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/SpaceShip.h	(revision 845)
@@ -75,5 +75,4 @@
             int emitterRate_;
     };
-    ExportClass(SpaceShip, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/Tickable.h
===================================================================
--- code/branches/core/src/orxonox/objects/Tickable.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/Tickable.h	(revision 845)
@@ -67,5 +67,4 @@
             Tickable() { RegisterRootObject(Tickable); }
     };
-    ExportAbstractClass(Tickable, Orxonox);
 
     //! The TickFrameListener calls the tick(dt) function of all Tickables every frame.
Index: code/branches/core/src/orxonox/objects/WorldEntity.h
===================================================================
--- code/branches/core/src/orxonox/objects/WorldEntity.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/WorldEntity.h	(revision 845)
@@ -147,5 +147,4 @@
       bool bStatic_;
   };
-  ExportClass(WorldEntity, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/weapon/AmmunitionDump.h
===================================================================
--- code/branches/core/src/orxonox/objects/weapon/AmmunitionDump.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/weapon/AmmunitionDump.h	(revision 845)
@@ -66,5 +66,4 @@
     int *capacity_;
   };
-  ExportClass(AmmunitionDump, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/weapon/BarrelGun.h
===================================================================
--- code/branches/core/src/orxonox/objects/weapon/BarrelGun.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/weapon/BarrelGun.h	(revision 845)
@@ -60,5 +60,4 @@
 
   };
-  ExportClass(BarrelGun, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/weapon/BaseWeapon.h
===================================================================
--- code/branches/core/src/orxonox/objects/weapon/BaseWeapon.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/weapon/BaseWeapon.h	(revision 845)
@@ -122,5 +122,4 @@
 
   };
-  ExportAbstractClass(BaseWeapon, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/weapon/Bullet.h
===================================================================
--- code/branches/core/src/orxonox/objects/weapon/Bullet.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/weapon/Bullet.h	(revision 845)
@@ -47,5 +47,4 @@
     inline virtual void loadParams(TiXmlElement* xmlElem) { Model::loadParams(xmlElem); };
  };
-  ExportClass(Bullet, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/objects/weapon/BulletManager.h
===================================================================
--- code/branches/core/src/orxonox/objects/weapon/BulletManager.h	(revision 843)
+++ code/branches/core/src/orxonox/objects/weapon/BulletManager.h	(revision 845)
@@ -67,5 +67,4 @@
 	  int bulletsIndex_;
   };
-  ExportClass(BulletManager, Orxonox);
 }
 
Index: code/branches/core/src/orxonox/tools/Timer.h
===================================================================
--- code/branches/core/src/orxonox/tools/Timer.h	(revision 843)
+++ code/branches/core/src/orxonox/tools/Timer.h	(revision 845)
@@ -104,5 +104,4 @@
             float time_;        //!< Internal variable, counting the time till the next function-call
     };
-    ExportAbstractClass(TimerBase, Orxonox);
 
     //! The Timer is a callback-object, calling a given function after a given time-interval.
@@ -158,5 +157,4 @@
             T* object_;
     };
-    ExportAbstractClass(Timer<BaseObject>, Orxonox);
 
     //! The TimerFrameListener manages all Timers in the game.
Index: code/branches/core/src/util/Convert.h
===================================================================
--- code/branches/core/src/util/Convert.h	(revision 843)
+++ code/branches/core/src/util/Convert.h	(revision 845)
@@ -41,5 +41,5 @@
 // DEFAULT CLASS
 template <typename FromType, typename ToType>
-class _UtilExport Converter
+class Converter
 {
   public:
@@ -52,5 +52,5 @@
 // PARTIAL SPECIALIZATION TO CONVERT TO STRINGS
 template<typename FromType>
-class _UtilExport Converter<FromType, std::string>
+class Converter<FromType, std::string>
 {
   public:
@@ -70,5 +70,5 @@
 // PARTIAL SPECIALIZATION TO CONVERT FROM STRING
 template<typename ToType>
-class _UtilExport Converter<std::string, ToType>
+class Converter<std::string, ToType>
 {
   public:
@@ -85,5 +85,5 @@
 // FUNCTION SO WE DO NOT HAVE TO TELL THE COMPILER ABOUT THE TYPE
 template<typename FromType, typename ToType>
-static _UtilExport bool ConvertValue(ToType* output, const FromType& input)
+static bool ConvertValue(ToType* output, const FromType& input)
 {
   Converter<FromType, ToType> converter;
@@ -93,5 +93,5 @@
 // THE SAME, BUT WITH DEFAULT VALUE
 template<typename FromType, typename ToType>
-static _UtilExport bool ConvertValue(ToType* output, const FromType& input, const ToType& fallback)
+static bool ConvertValue(ToType* output, const FromType& input, const ToType& fallback)
 {
   Converter<FromType, ToType> converter;
@@ -108,5 +108,5 @@
 // Vector2 to std::string
 template <>
-class _UtilExport Converter<orxonox::Vector2, std::string>
+class Converter<orxonox::Vector2, std::string>
 {
   public:
@@ -126,5 +126,5 @@
 // Vector3 to std::string
 template <>
-class _UtilExport Converter<orxonox::Vector3, std::string>
+class Converter<orxonox::Vector3, std::string>
 {
   public:
@@ -144,5 +144,5 @@
 // Vector4 to std::string
 template <>
-class _UtilExport Converter<orxonox::Vector4, std::string>
+class Converter<orxonox::Vector4, std::string>
 {
   public:
@@ -162,5 +162,5 @@
 // Quaternion to std::string
 template <>
-class _UtilExport Converter<orxonox::Quaternion, std::string>
+class Converter<orxonox::Quaternion, std::string>
 {
   public:
@@ -180,5 +180,5 @@
 // ColourValue to std::string
 template <>
-class _UtilExport Converter<orxonox::ColourValue, std::string>
+class Converter<orxonox::ColourValue, std::string>
 {
   public:
Index: code/branches/core/src/util/Math.h
===================================================================
--- code/branches/core/src/util/Math.h	(revision 843)
+++ code/branches/core/src/util/Math.h	(revision 845)
@@ -59,5 +59,5 @@
 
 template <typename T>
-inline _UtilExport T sgn(T x)
+inline T sgn(T x)
 {
     return (x >= 0) ? 1 : -1;
@@ -65,5 +65,5 @@
 
 template <typename T>
-inline _UtilExport T min(T a, T b)
+inline T min(T a, T b)
 {
     return (a <= b) ? a : b;
@@ -71,5 +71,5 @@
 
 template <typename T>
-inline _UtilExport T max(T a, T b)
+inline T max(T a, T b)
 {
     return (a >= b) ? a : b;
@@ -77,5 +77,5 @@
 
 template <typename T>
-inline _UtilExport T clamp(T x, T min, T max)
+inline T clamp(T x, T min, T max)
 {
     if (x < min)
@@ -89,5 +89,5 @@
 
 template <typename T>
-inline _UtilExport T square(T x)
+inline T square(T x)
 {
     return x*x;
@@ -95,5 +95,5 @@
 
 template <typename T>
-inline _UtilExport T cube(T x)
+inline T cube(T x)
 {
     return x*x*x;
@@ -101,5 +101,5 @@
 
 template <typename T>
-inline _UtilExport int floor(T x)
+inline int floor(T x)
 {
     return (int)(x);
@@ -107,5 +107,5 @@
 
 template <typename T>
-inline _UtilExport int ceil(T x)
+inline int ceil(T x)
 {
     int temp = floor(x);
@@ -114,5 +114,5 @@
 
 template <typename T>
-inline _UtilExport int round(T x)
+inline int round(T x)
 {
     return (int)(x + 0.5);
@@ -120,5 +120,5 @@
 
 template <typename T>
-_UtilExport T interpolate(float time, const T& start, const T& end)
+T interpolate(float time, const T& start, const T& end)
 {
     return time * (end - start) + start;
@@ -126,5 +126,5 @@
 
 template <typename T>
-_UtilExport T interpolateSmooth(float time, const T& start, const T& end)
+T interpolateSmooth(float time, const T& start, const T& end)
 {
     return (-2 * (end - start) * cube(time)) + (3 * (end - start) * square(time)) + start;
Index: code/branches/core/src/util/String2Number.h
===================================================================
--- code/branches/core/src/util/String2Number.h	(revision 843)
+++ code/branches/core/src/util/String2Number.h	(revision 845)
@@ -24,5 +24,5 @@
 
 template <class T>
-class _UtilExport String2Number
+class String2Number
 {
   private: